; 

    include \masm32\include\masm32rt.inc

  ; ****************************************************************************

    uni2$ MACRO quoted@@text:VARARG

    ;; ---------------------------------------------------
    ;; ASCII literal string to UNICODE "dw" conversion.
    ;; The macro has the ASCII character range 0 - 255
    ;; and will convert 1 byte characters in the quoted
    ;; string to 2 byte UNICODE characters written as "dw"
    ;; in the initialised data section.
    ;; ---------------------------------------------------

      LOCAL s_l_e_n
      LOCAL c_n_t_r
      ;; LOCAL item
      LOCAL add@str1
      LOCAL DATA@LABEL
      LOCAL isquot
      LOCAL argz

      LOCAL new@str1

      LOCAL slice@1
      LOCAL slice@2
      LOCAL slice@3
      LOCAL slice@4
      LOCAL slice@5
      LOCAL slice@6

      add@str1 equ <>

      new@str1 equ <>

      slice@1 equ <>
      slice@2 equ <>
      slice@3 equ <>
      slice@4 equ <>
      slice@5 equ <>
      slice@6 equ <>

      s_l_e_n SIZESTR <quoted@@text>
 ;;       item TEXTEQU %(s_l_e_n)
 ;;       % echo string length = item characters

      if s_l_e_n gt 240
        echo -----------------------
        echo *** STRING TOO LONG ***
        echo -----------------------
      .ERR
      EXITM <>
      endif

      isquot SUBSTR <quoted@@text>,1,1
      IFDIF isquot,<">
        echo -----------------------------
        echo *** MISSING LEADING QUOTE ***
        echo -----------------------------
      .ERR
      EXITM <>
      ENDIF

      isquot SUBSTR <quoted@@text>,s_l_e_n,1
      IFDIF isquot,<">
        echo ------------------------------
        echo *** MISSING TRAILING QUOTE ***
        echo ------------------------------
      .ERR
      EXITM <>
      ENDIF

    ;; **************************************
    % echo quoted@@text <-------<<< this is unmodified
    ;; **************************************

    ;; ---------------------------------------------------
    ;; trim the leading and trailing quote from the string
    ;; ---------------------------------------------------
      new@str1 SUBSTR <quoted@@text>,2,s_l_e_n-2

    ;; **************************************
    % echo new@str1 <+++++++<<< This is where the API substitution happens
    % echo     
    ;; **************************************

    ;; ============================================

      c_n_t_r = 0

      % FORC argz, <new@str1>

          if c_n_t_r lt 1
            slice@1 CATSTR slice@1,<">,<argz>,<">
          elseif c_n_t_r lt 40
            slice@1 CATSTR slice@1,<,">,<argz>,<">
            goto nxt

          elseif c_n_t_r lt 41
            slice@2 CATSTR slice@2,<">,<argz>,<">
          elseif c_n_t_r lt 80
            slice@2 CATSTR slice@2,<,">,<argz>,<">
            goto nxt

          elseif c_n_t_r lt 81
            slice@3 CATSTR slice@3,<">,<argz>,<">
          elseif c_n_t_r lt 120
            slice@3 CATSTR slice@3,<,">,<argz>,<">
            goto nxt

          elseif c_n_t_r lt 121
            slice@4 CATSTR slice@4,<">,<argz>,<">
          elseif c_n_t_r lt 160
            slice@4 CATSTR slice@4,<,">,<argz>,<">
            goto nxt

          elseif c_n_t_r lt 161
            slice@5 CATSTR slice@5,<">,<argz>,<">
          elseif c_n_t_r lt 200
            slice@5 CATSTR slice@5,<,">,<argz>,<">
            goto nxt

          elseif c_n_t_r lt 201
            slice@6 CATSTR slice@6,<">,<argz>,<">
          elseif c_n_t_r lt 240
            slice@6 CATSTR slice@6,<,">,<argz>,<">
            goto nxt
          endif

      :nxt
        c_n_t_r = c_n_t_r + 1
      ENDM

    ;; ============================================

    .data

      % s_l_e_n SIZESTR <slice@1>
      if s_l_e_n ne 0
        slice@1 CATSTR <DATA@LABEL dw >,slice@1
        slice@1
      endif

      % s_l_e_n SIZESTR <slice@2>
      if s_l_e_n ne 0
        slice@2 CATSTR <dw >,slice@2
        slice@2
      endif

      % s_l_e_n SIZESTR <slice@3>
      if s_l_e_n ne 0
        slice@3 CATSTR <dw >,slice@3
        slice@3
      endif

      % s_l_e_n SIZESTR <slice@4>
      if s_l_e_n ne 0
        slice@4 CATSTR <dw >,slice@4
        slice@4
      endif

      % s_l_e_n SIZESTR <slice@5>
      if s_l_e_n ne 0
        slice@5 CATSTR <dw >,slice@5
        slice@5
      endif

      % s_l_e_n SIZESTR <slice@6>
      if s_l_e_n ne 0
        slice@6 CATSTR <dw >,slice@6
        slice@6
      endif

      dw 0

    .code

      EXITM <OFFSET DATA@LABEL>

    ENDM

  ; ****************************************************************************

    .code

start:
   
; 

    call main

    exit

; 

main proc

    fn MessageBoxW,0,uni2$("This is the text message containing the API MessageBox   "),uni2$("Title Text"),MB_OK

    ret

main endp

; 

end start
